import 'dotenv/config';
import express, { Express } from 'express';
import Room from './Room.js';

export interface IRoomMap {
  [name: string]: Room;
}

export interface IAppContext {
  env: Record<string, string>;
  logger: any;
  db: any;
  roomTimers: {};
  sound: any;
  cb: any;
  dataDir: any;
  gotClient: any;
  faye: any | null;
  expressApp: Express;
  rooms: IRoomMap;
}

export const appEnv: string[] = ['PUBSUB_SERVER_URL'];

export function getAppContext(
  appEnv: string[],
  logger: any,
  db: any,
  sound: any,
  cb: any,
  dataDir: any,
  gotClient: any
) {
  return {
    env: appEnv.reduce((acc: any, ev: string) => {
      if (typeof process.env[ev] === 'undefined') throw new Error(`${ev} is undefined in env`);
      acc[ev] = process.env[ev];
      return acc;
    }, {}),
    logger,
    db,
    roomTimers: {},
    sound,
    cb,
    dataDir,
    gotClient,
    faye: null,
    expressApp: express(),
    rooms: {}
  };
}
