import faye from 'faye';

export function fayeFactory(appContext: any): faye.Client {
  return new faye.Client(appContext.env.PUBSUB_SERVER_URL);
}

export async function sendSignal(appContext: any, message: any): Promise<void> {
  return appContext.faye.publish('/signals', message);
}

export async function signalStart(appContext: any, roomName: string, playlistUrl: string): Promise<void> {
  appContext.logger.log({ level: 'debug', message: `signalStart has been called with roomName:${roomName}, playlistUrl:${playlistUrl}` });
  if (appContext === undefined) throw new Error('appContext undef');
  if (roomName === undefined) throw new Error('roomName undef');
  if (playlistUrl === undefined) throw new Error('playlistUrl undef');
  await sendSignal(appContext, { signal: 'start', room: roomName, url: playlistUrl });
}
