
import { expect } from "chai";

import AblyWrapper from '../../src/AblyWrapper.ts'
import Database from 'better-sqlite3'
import path from 'node:path'
import os from 'node:os'

describe('AblyWrapper', function () {
    describe('getRealtimeUrls', function () {
        it('should load urls from db', function () {
            let appContext = {
                db: new Database(path.join(os.homedir(), '.local/share/futureporn-scout/scout.db'))
            }
            let aw = new AblyWrapper(appContext, { chaturbateAuth: {} }) // dummy cbAuth
            expect(aw.getRealtimeUrls()).to.deep.equal({
                restHost: 'realtime.pa.highwebmedia.com',
                realtimeHost: 'realtime.pa.highwebmedia.com',
                fallbackHosts: ['a-fallback.pa.highwebmedia.com', 'b-fallback.pa.highwebmedia.com', 'c-fallback.pa.highwebmedia.com', 'd-fallback.pa.highwebmedia.com', 'e-fallback.pa.highwebmedia.com']
            })
        })
    })
})

